﻿Public Class FormMain
    Dim Hero As ClassCreature.Creature
    Dim SlimeBall As ClassCreature.Creature
    Dim SmallSpider As ClassCreature.Creature
    Dim LargeSpider As ClassCreature.Creature
    Dim Opponent As ClassCreature.Creature
    Public Score As Integer
    Const MagicPower As Integer = 10

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadSettings()

    End Sub

    Private Sub ButtonQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonQuit.Click
        Close()  'Closes the main form - quits the applicaton
    End Sub

    Private Sub GetEnemy()

        Dim EnemyNumber As Integer

        Randomize()   'used for Rnd()

        EnemyNumber = (Rnd() * 2) + 1  ' Gets 1, 2, or 3

        If EnemyNumber = 1 Then
            Opponent = SlimeBall
        ElseIf EnemyNumber = 2 Then
            Opponent = SmallSpider
        Else
            Opponent = LargeSpider
        End If

        WriteStats()

    End Sub

    Private Sub ButtonFight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFight.Click
        Randomize()
        Hero.Health = Hero.Health - (Rnd() * Opponent.Power) 'hero is hit
        Randomize()
        Opponent.Health = Opponent.Health - (Rnd() * Hero.Power) 'Opponent is hit
        CheckDeath()
    End Sub

    Private Sub ButtonMagic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMagic.Click
        If Hero.Magic > 0 Then  ' if hero has magic
            Opponent.Health = Opponent.Health - MagicPower  ' opponent is hit with magic
            Hero.Magic = Hero.Magic - 1  ' magic subtracted by one

            If Opponent.Health > 0 Then   ' Opponent survives, it can hit back
                Hero.Health = Hero.Health - (Rnd() * Opponent.Power)
            End If
            CheckDeath()
        End If
    End Sub

    Private Sub WriteStats()

        TextBoxHero.Clear()
        TextBoxHero.Text = "Name = " + Hero.Name + vbNewLine
        TextBoxHero.Text += "Health = " + Str(Hero.Health) + vbNewLine
        TextBoxHero.Text += "Armor = " + Str(Hero.Armor) + vbNewLine
        TextBoxHero.Text += "Magic = " + Str(Hero.Magic) + vbNewLine
        TextBoxHero.Text += "Power = " + Str(Hero.Power) + vbNewLine

        TextBoxOpponent.Clear()
        TextBoxOpponent.Text = "Opponent = " + Opponent.Name + vbNewLine
        TextBoxOpponent.Text += "Health = " + Str(Opponent.Health) + vbNewLine
        TextBoxOpponent.Text += "Armor = " + Str(Opponent.Armor) + vbNewLine
        TextBoxOpponent.Text += "Magic = " + Str(Opponent.Magic) + vbNewLine
        TextBoxOpponent.Text += "Power = " + Str(Opponent.Power) + vbNewLine

    End Sub

    Private Sub CheckDeath()

        WriteStats()

        If Opponent.Health <= 0 Then   ' if opponent is killed
            LabelKilled.Text = "Killed: " + Opponent.Name
            Score += Opponent.Power 'add to hero's score
            LabelScore.Text = "Score = " + Str(Score)
            GetEnemy() 'get new enemy
        Else
            LabelKilled.Text = "Enemy Not Killed"
        End If

        If Hero.Health <= 0 Then   ' if hero killed
            PlayAgain.ShowDialog()
        End If

    End Sub

    Public Sub LoadSettings()
        Score = 0

        LabelScore.Text = "Score = " + Str(Score)
        LabelKilled.Text = ""

        Hero.Name = "Sir Bill"
        Hero.Armor = 0
        Hero.Health = 20
        Hero.Magic = 2
        Hero.Power = 5

        SlimeBall.Name = "SlimeBall"
        SlimeBall.Armor = 0
        SlimeBall.Health = 1
        SlimeBall.Magic = 0
        SlimeBall.Power = 1

        SmallSpider.Name = "Small Spider"
        SmallSpider.Armor = 0
        SmallSpider.Health = 1
        SmallSpider.Magic = 0
        SmallSpider.Power = 2

        LargeSpider.Name = "Large Spider"
        LargeSpider.Armor = 0
        LargeSpider.Health = 2
        LargeSpider.Magic = 0
        LargeSpider.Power = 2

        GetEnemy()
    End Sub
End Class
